package com.lwby.marketing.att.dyvideo.handle;

import com.lwby.marketing.att.bystory.CallBackType;
import com.lwby.marketing.att.dyvideo.DyVideoUniversalProcess;
import com.lwby.marketing.flow.NodeFlow;
import com.lwby.marketing.notify.Media;
import com.lwby.marketing.notify.media.Platform;
import com.lwby.marketing.po.VideoUpload;
import com.lwby.marketing.util.DateTimUtils;
import com.lwby.marketing.util.NumberUtils;
import com.lwby.marketing.vo.ClientInfo;
import com.lwby.marketing.vo.DeliveryDeviceInfo;
import com.lwby.marketing.vo.StoryNovelAction;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Objects;
import java.util.UUID;

@Slf4j
@Component("dyvideo_setup")
public class ParameterSetupDyVideoFlow extends NodeFlow<StoryNovelAction> {
    @Resource
    DyVideoUniversalProcess up;

    @Override
    public void process(StoryNovelAction action) {
        ClientInfo clientInfo = action.getClientInfo();
        String openId = action.getOpenId();

        //平台ID
        Integer platformId = clientInfo.getPlatformId();
        //VO对像
        DeliveryDeviceInfo deliveryDeviceInfo = null;

        //String s = "{\"creativeId\":\"112331\",\"creativeType\":\"3\",\"adid\":\"12321\","
        //        + "\"clickId\":\"12312143232\",\"channel\":\"216011231\",\"bookId\":\"4322111\","
        //        + "\"media\":\"jrtt\",\"clickTime\":123123123,\"code\":\"12ede3e231\"}";;
        //StoryLogin storyLogin = JSONObject.parseObject(s,StoryLogin.class);
        //匹配OpenId
        VideoUpload videoUpload = up.get(VideoUpload.class,assembleKey(openId));
        action.setVideoUpload(videoUpload);

        //StoryNovelAction对像参数填充
        action.setPlatformId(platformId);
        action.setUserId(action.getUserId());
        action.setCurrentDateStr(DateTimUtils.getCurrentDateString());

        if (CallBackType.active.getType().equals(0)) {
            action.setChannelId((long)action.getClientInfo().getChannel());
        }


        //非商店吊起参数设置
        if (Objects.nonNull(videoUpload)) {
            deliveryDeviceInfo = new DeliveryDeviceInfo();
            deliveryDeviceInfo.setAd_creative_id(videoUpload.getCreativeId());
            deliveryDeviceInfo.setPlatform_id(String.valueOf(clientInfo.getPlatformId()));
            deliveryDeviceInfo.setCallback_param(videoUpload.getClickId());
            deliveryDeviceInfo.setUuid(UUID.randomUUID().toString());
            deliveryDeviceInfo.setDj_channel(videoUpload.getChannel());
            deliveryDeviceInfo.setPromotion_id(videoUpload.getAdid());
            deliveryDeviceInfo.setVideoResourceId(videoUpload.getVideoResourceId());
            action.setDeliveryDeviceInfo(deliveryDeviceInfo);
            action.setChannelId(NumberUtils.parseLong(videoUpload.getChannel()));
            action.setPlanId(NumberUtils.parseLong((videoUpload.getAdid())));
            action.setMediaName(videoUpload.getMedia());
            action.setMedia(Media.getMedia(action.getMediaName(), Platform.DY_VIDEO));
        }
    }

    public String assembleKey(String openId) {
        return String.format("story:upload:%s", openId);
    }
}
